package explicit;

import prism.PrismException;

public interface ProductOperator<G>
{
	/** Get the product state when considering some initial state in the Graph */
	public ProductState getInitialState(Integer graph_state);
	/** Get the successor state for the ProductState when going to dtmc_to_state in the Graph */
	public ProductState getSuccessor(ProductState from_state, Integer graph_to_state);

	/** notifies the Operator that state is assigned index in the product.
	 * Guaranteed to be called exactly once during the product construction for every
	 * ProductState.
	 * @throws PrismException
	 */
	public void notify(ProductState state, Integer index) throws PrismException;
	
	/** Get the underlying Graph */
	public G getGraph();
	/** Get some extra info to store in the product */
	public Object getExtraInfo();

}
