package explicit;

public class ProductState implements Comparable<ProductState>
{
	private Integer state_1;
	private Integer state_2;


	public ProductState(Integer state_1, Integer state_2)
	{
		this.state_1 = state_1;
		this.state_2 = state_2;
	}
	
	public Integer getFirstState()
	{
		return state_1;
	}

	public Integer getSecondState()
	{
		return state_2;
	}


	@Override
	public String toString()
	{
		return "[" + state_1 + "," + state_2 + "]";
	}

	@Override
	public int compareTo(ProductState other)
	{
		int rv = state_1.compareTo(state_2);
		if (rv == 0) {
			return state_2.compareTo(other.state_2);
		} else {
			return rv;
		}
	}

	@Override
	public int hashCode()
	{
		final int prime = 31;
		int result = 1;
		result = prime * result + ((state_1 == null) ? 0 : state_1.hashCode());
		result = prime * result + ((state_2 == null) ? 0 : state_2.hashCode());
		return result;
	}

	@Override
	public boolean equals(Object obj)
	{
		if (this == obj)
			return true;
		if (obj == null)
			return false;
		if (getClass() != obj.getClass())
			return false;
		ProductState other = (ProductState) obj;
		return state_1.equals(other.state_1) &&
				state_2.equals(other.state_2);
	}

}
