package explicit.conditional;

import parser.ast.Expression;
import parser.ast.ExpressionReward;
import parser.ast.ExpressionTemporal;

public class ExpressionInspector {

	private Expression expression;

	public ExpressionInspector(Expression expression) {
		this.expression = expression;
	}

	public boolean isReachablilityReward() {
		if (expression instanceof ExpressionReward) {
			Expression subexpression = ((ExpressionReward) expression).getExpression();
			if (subexpression instanceof ExpressionTemporal) {
				return ((ExpressionTemporal) subexpression).getOperator() == ExpressionTemporal.R_F;
			}
		}
		return false;
	}

	public boolean isSteadyStateReward() {
		if (expression instanceof ExpressionReward) {
			Expression subexpression = ((ExpressionReward) expression).getExpression();
			if (subexpression instanceof ExpressionTemporal) {
				return ((ExpressionTemporal) subexpression).getOperator() == ExpressionTemporal.R_S;
			}
		}
		return false;
	}
}
