package explicit.conditional;

import java.util.Arrays;
import java.util.BitSet;

import prism.PrismException;

import explicit.DTMC;
import explicit.DTMCModelChecker;
import explicit.ModelCheckerResult;
import explicit.ProbModelChecker;

public class UntilTransformation extends DoubleTransformation {

	public UntilTransformation(ProbModelChecker mc) {
		super(mc);
	}

	public DTMC transformModel(final DTMC model, final BitSet target) throws PrismException {
		// FIXME: do not expect mc to be a DTMCModelChecker
		final ModelCheckerResult result = ((DTMCModelChecker) mc).computeReachProbs(model, target);
		final double[] probabilities = result.soln;
		
		return transformModel(model, probabilities, target);
	}

	public DTMC transformModel(final DTMC model, final BitSet remain, final BitSet target) throws PrismException {
		// FIXME: do not expect mc to be a DTMCModelChecker
		final ModelCheckerResult result = ((DTMCModelChecker) mc).computeUntilProbs(model, remain, target);
		final double[] probabilities = result.soln;

		return transformModel(model, probabilities, target);
	}

	public int mapStateToOrigin(int state) {
		int index = Arrays.asList(stateMappingModeOne).indexOf(state);
		if (index < 0) {
			index = Arrays.asList(stateMappingModeTwo).indexOf(state);
		}
		return index;
	}
}
